<%@ page description="template control example" %>
<%@ import namespace="System.Data" %>

<script language="VB" runat="server">

Function CreateDataSource() As ICollection

    Dim dt As DataTable
    Dim dr As DataRow
    Dim i As Integer

    'create a DataTable
    dt = New DataTable
    with dt.Columns
      .Add(New DataColumn("IntegerValue", GetType(Integer)))
      .Add(New DataColumn("StringValue", GetType(String)))
      .Add(New DataColumn("DateTimeValue", GetType(DateTime)))
    end with

    'Make some rows and put some sample data in
    For i = 1 To 9
        dr = dt.NewRow()
        dr(0) = i
        dr(1) = "Item " & i.ToString()
        dr(2) = DateTime.Now.ToShortTimeString
        dt.Rows.Add(dr)
    Next

    'return a DataView to the DataTable
    CreateDataSource = New DataView(dt)

End Function

Sub Page_Load(sender As Object, e As EventArgs)
   
    if Not IsPostBack Then
        BindList
    end If
        
End Sub

Sub BindList
    DataList1.DataSource= CreateDataSource()
    DataList1.DataBind
End Sub

Sub DataList_ItemCommand(sender As Object, e As DataListCommandEventArgs)
    Dim cmd As String = e.CommandSource.CommandName
    If cmd = "select" Then
        DataList1.SelectedIndex = e.Item.ItemIndex
    End If

    BindList
End Sub

</script>

<html>
<body>
<h2>Template Control Example</h2>
<hr />

<form runat=server>
  <asp:DataList id="DataList1" runat="server"
      OnItemCommand="DataList_ItemCommand">
      <HeaderTemplate>
          Items
          <hr />
      </HeaderTemplate>
              
      <ItemTemplate>
        <asp:LinkButton id="button1" runat="server" 
            Text="Details" CommandName="select" />
        <%# DataBinder.Eval(Container.DataItem, "StringValue") %>
      </ItemTemplate>
              
      <SelectedItemTemplate>
        Item:
        <%# Container.DataItem("StringValue")  %><br>
        Order Date:
        <%# DataBinder.Eval(Container.DataItem, "DateTimeValue", "{0:d}") %><br>
        Quantity:
        <%# DataBinder.Eval(Container.DataItem, "IntegerValue", "{0:N1}") %><br>
      </SelectedItemTemplate>

      <FooterTemplate>
          <hr />
      </FooterTemplate>
  </asp:DataList>

</form>

</body>
</html>



