<%@ Page Description="CheckBoxListDB.aspx" trace="false"%>
<%@ import namespace="System.Data" %>

<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "DTD/xhtml1-transitional.dtd">

<script Language="VB" runat="server">

' display list the very first time only
sub Page_Load(Source As object, e As EventArgs)

   if IsPostBack=false then
      with cbListDB
         .DataSource = CreateDataSource()
         .DataTextField="ItemName"
         .DataValueField="ItemSelected"
         .DataBind()
      end with
   end if
   
end sub   

' fix up checked display at load time
sub Check_OnLoad(Sender As Object, E As EventArgs)
  	
    dim i As Integer
    
    if Page.IsPostBack=false then
      for i = 0 to cbListDB.Items.Count-1
         if cbListDB.Items(i).Value="True" then
  	       	cbListDB.Items(i).Selected = true
  	     end if
      next
      ShowResults()
    end if
    
end sub

' build selection list for display
sub Check_Clicked(sender As Object, e As EventArgs)
   ShowResults()  
end sub

' output results of checked boxes
sub ShowResults()
   
   Dim i As Integer
    
   Message.Text = "You selected:<ul>"
      
   For i=0 To cbListDB.Items.Count - 1
      if cbListDB.Items(i).Selected Then
         Message.Text &= "<li>" & cbListDB.Items(i).Text & "</li>"
      end if
   Next
     
   Message.Text &= "</ul>"

end sub

' create some data for this example
function CreateDataSource() as DataView

   dim dt as DataTable = new DataTable()
   dim dr as DataRow
   dim i as integer
   
   with dt.Columns
      .Add(new DataColumn("ItemName",GetType(String)))
      .Add(new DataColumn("ItemSelected",GetType(boolean)))
   end with
   
   for i=0 to 4
      dr = dt.NewRow()
      dr(0) = "Widget " & chr(i+65)
      if i=1 or i=3 then
         dr(1) = true
      else
         dr(1) = false
      end if
      
      dt.rows.Add(dr)
   next
   
   dim dv as DataView = new DataView(dt)
   return dv
   
end function

</script>

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">

<head>

<title id="title" runat="server" />

<meta name="title"      content="ASP.NET for Developers" />
<meta name="isbn"       content="0-672-32038-X" />
<meta name="Authors"    content="Mike Amundsen and Paul Litwin" />
<meta name="Publisher"  content="Sams Publishing" />
<meta name="website"    content="http://www.aspxdev/" />
<meta name="email"      content="aspx4devs@amundsen.com" />
<meta name="VSS Info"   content="$$Header: $" />

<link rel="stylesheet" type="text/css" href="aspx4devs.css" />

</head>

<body>

<h2>Data Bound Check Box List Demo</h2>
<hr />

<form runat="server">

    <asp:CheckBoxList id="cbListDB" 
        RepeatColumns="2"
        TextAlign="right"
        AutoPostBack="True"
        OnSelectedIndexChanged="Check_Clicked"
        OnLoad="Check_OnLoad"
        runat="server">
 
    </asp:CheckBoxList>
 
    <p>
    <asp:label id="Message" runat="server"/>
    </p>

</form>

</body>

</html>
