<%@ Page Description="editing in a data grid"%>
<%@ import namespace="System.Data" %>

<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "DTD/xhtml1-transitional.dtd">

<script language="VB" runat="server">

Dim runningTotal As Double = 0

sub Page_Load(sender As Object, e As EventArgs)
  if not IsPostBack then
      bindGrid
  end if
end sub

sub btnUpdate_click(sender As Object, e As EventArgs)
  
  dim i as integer
  dim dr As DataRow

  ' move new qty values into dataset
  for i = 0 To dbList.Items.Count - 1
    dr = Cart.Rows(i)
    dr(0) = CType(dbList.items(i).FindControl("txtQty"),TextBox).Text
  next
  bindGrid

end sub

sub bindGrid()
  dbList.DataSource = Cart.DefaultView
  dbList.DataBind()
end sub

function getTotal (count As Integer, price As Double) As Double
  dim total As Double
   
  ' update total for item and cart 
  total = count * price
  runningTotal += total
  grossAmount.Text=String.Format("{0:c}",runningTotal)
  
  return(total)
  
end function

ReadOnly Property Cart As DataTable
  get
    ' get the data from a session var
    if Session("dbList_Cart") Is Nothing Then
      dim tmpCart as DataTable = createData()
      Session("dbList_Cart")=tmpCart
    end if
    return Session("dbList_Cart")
  end get
end property

function createData() as DataTable
   ' create new data and place it in a session var
   dim tmpCart as new DataTable()
   dim i As Integer
   dim dr As DataRow
   
   tmpCart.Columns.Add(new DataColumn("Qty", GetType(String)))
   tmpCart.Columns.Add(new DataColumn("Product", GetType(String)))
   tmpCart.Columns.Add(new DataColumn("Price", GetType(Double)))

   for i= 1 to 6
     dr = tmpCart.NewRow()
     dr(0) = "1"
     dr(1) = "Product " & i.ToString
     dr(2) = 1.25 * (i+1)
     tmpCart.Rows.Add(dr)
   next
   
   return tmpCart

end function

</script>

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">

<head>

<title id="title" runat="server" />

<meta name="title"      content="ASP.NET for Developers" />
<meta name="isbn"       content="0-672-32038-X" />
<meta name="Authors"    content="Mike Amundsen and Paul Litwin" />
<meta name="Publisher"  content="Sams Publishing" />
<meta name="website"    content="http://www.amundsen.com/books/aspx4devs/" />
<meta name="email"      content="aspx4devs@amundsen.com" />
<meta name="VSS Info"   content="$$Header: $" />

<link rel="stylesheet" type="text/css" href="aspx4devs.css" />

</head>

<body>

<h2>DataGrid Edit Demo</h2>
<hr />

<form runat="server">

<asp:DataGrid id="dbList" runat="server"
  AutoGenerateColumns="false">
  <Columns>
    <asp:TemplateColumn HeaderText="Quantity">
      <ItemTemplate>
        <asp:TextBox id=txtQty runat="server"
          Text='<%# DataBinder.Eval(Container.DataItem, "Qty") %>'
          Width="40px"
        />
      </ItemTemplate>
    </asp:TemplateColumn>
    <asp:BoundColumn HeaderText="Product" DataField="Product"/>
    <asp:BoundColumn HeaderText="Price" DataField="Price" DataFormatString="{0:c}" />
    <asp:TemplateColumn HeaderText="SubTotal">
      <ItemTemplate>
        <p align="right">
        <asp:Label runat="server"
          Text='<%# System.String.Format("{0:c}", _
          getTotal(Int32.Parse(Container.DataItem("Qty")), _
          Container.DataItem("Price"))) %>'
        />
        </p>
      </ItemTemplate>
    </asp:TemplateColumn>
  </Columns>
</asp:DataGrid>

<h4>
Cart total: 
<asp:Label id="grossAmount" runat="server"/>
</h4>

<asp:LinkButton id=btnUpdate runat="server"
  Text="Update Totals"
  onClick="btnUpdate_click"/>

</form>

</body>

</html>
