<%@ Page Description="DataList.aspx" %>
<%@ import namespace="System.Data" %>

<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "DTD/xhtml1-transitional.dtd">

<script Language="VB" runat="server">

' shared objects
dim Cart As DataTable
dim CartView As DataView

' handles cart state management                
Sub Page_Load(sender As Object, e As EventArgs)

    CreateCart()
    CartView = New DataView(Cart)
    CartView.Sort="Item"
    
       if Not IsPostBack Then
        ' need to load this data only once
        BindList
    End If

End Sub

' bind cart to control
Sub BindList()
        
    dbList.DataSource= CartView
    dbList.DataBind
    
End Sub

sub dbList_ItemCommand(sender as object, args as DataListCommandEventArgs)

   dbList.SelectedIndex = args.Item.ItemIndex
   BindList()
   
end sub

sub reset_click(sender as object, args as EventArgs)
   
   dbList.SelectedIndex = -1
   BindList()

end sub

' create some data for this example 
function CreateCart()
               
   dim dr As DataRow
   dim i As Integer

   ' create a new data table object
   Cart = new DataTable()
   with Cart.Columns
      .Add(new DataColumn("Qty", GetType(String)))
      .Add(new DataColumn("Item", GetType(String)))
      .Add(new DataColumn("Price", GetType(String)))
   end with
   
   ' add data to table
   for i = 1 To 4
       dr = Cart.NewRow()
       
       if (i Mod 2 <> 0) Then
           dr(0) = "2"
       else
           dr(0) = "1"
       end if
       
       dr(1) = "Widget " & chr(i+64)
       dr(2) = (1.23 * (i + 1)).ToString
       
       Cart.Rows.Add(dr)
   Next

   return Cart
      
end function

</script>

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">

<head>

<title id="title" runat="server" />

<meta name="title"      content="ASP.NET for Developers" />
<meta name="isbn"       content="0-672-32038-X" />
<meta name="Authors"    content="Mike Amundsen and Paul Litwin" />
<meta name="Publisher"  content="Sams Publishing" />
<meta name="website"    content="http://www.amundsen.com/books/aspx4devs/" />
<meta name="email"      content="aspx4devs@amundsen.com" />
<meta name="VSS Info"   content="$$Header: $" />

<link rel="stylesheet" type="text/css" href="aspx4devs.css" />

</head>

<body>

<h2>DataList Demo</h2>
<hr />

<form runat="server" color=>

        <asp:DataList id="dbList"
            BorderWidth="2"
            Width="250"
            
            HeaderStyle-BackColor="gray"
            AlternatingItemStyle-BackColor="silver"
            EditItemStyle-BackColor="gainsboro"
            
            OnItemCommand="dbList_ItemCommand"
            
            runat="server">
            
            <HeaderTemplate>
                <h3 align="center" valign="middle" >
                Product List &nbsp;&nbsp;&nbsp;
                <asp:Button Text="Reset" OnClick="reset_click" runat="server"/>
                </h3>
            </HeaderTemplate>
            
            <ItemTemplate>
                <asp:LinkButton id="btnEdit" runat="server" 
                    Text='<%# Container.DataItem("Item")%>' CommandName="Select" />
            </ItemTemplate>
            
            <SelectedItemTemplate>
                <table>
                    <tr>
                        <td>Item:</td>
                        <td><asp:Label id="item" runat="server" 
                            Text='<%# Container.DataItem("Item")  %>' />
                        </td>
                    </tr>
                    <tr>
                        <td>Quantity:</td>
                        <td><asp:TextBox id="qty" size="15" runat="server" 
                            Text='<%# Container.DataItem("Qty")  %>' />
                        </td>
                    </tr>
                    <tr>
                        <td>Price:</td>
                        <td><asp:TextBox id="price" size="15" runat="server" 
                            Text='<%# DataBinder.Eval(Container.DataItem, "Price") %>' />
                        </td>
                    </tr>
                </table>
            </SelectedItemTemplate>

        </asp:DataList>

</form>

</body>

</html>
