<%@ Page Description="RadioButtonListDB.aspx" %>
<%@ import namespace="System.Data" %>

<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "DTD/xhtml1-transitional.dtd">

<script Language="VB" runat="server">

' display list the very first time only
sub Page_Load(Source As object, e As EventArgs)

   if IsPostBack=false then
      with rbListDB
         .DataSource = CreateDataSource()
         .DataTextField="ItemName"
         .DataValueField="ItemAmount"
         .DataBind()
      end with
   end if
   
end sub   

' handle clicks on the radio button
sub rbListDB_Changed(sender as object, e as EventArgs)

   msgDisplay.Text = "You selected <b>" & _
      rbListDB.SelectedItem.text & _
      "</b> with a cost of <b>" & _
      rbListDB.SelectedItem.Value & "</b>."
      
end sub

' create some data for this example
function CreateDataSource() as DataView

   dim dt as DataTable = new DataTable()
   dim dr as DataRow
   dim i as integer
   
   with dt.Columns
      .Add(new DataColumn("ItemName",GetType(String)))
      .Add(new DataColumn("ItemAmount",GetType(double)))
   end with
   
   for i=0 to 5
      dr = dt.NewRow()
      dr(0) = "Wrapping Option " & cStr(i)
      dr(1) = 1.23 * (i+1)
      
      dt.rows.Add(dr)
   next
   
   dim dv as DataView = new DataView(dt)
   return dv
   
end function

</script>

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">

<head>

<title id="title" runat="server" />

<meta name="title"      content="ASP.NET for Developers" />
<meta name="isbn"       content="0-672-32038-X" />
<meta name="Authors"    content="Mike Amundsen and Paul Litwin" />
<meta name="Publisher"  content="Sams Publishing" />
<meta name="website"    content="http://www.aspxdev/" />
<meta name="email"      content="aspx4devs@amundsen.com" />
<meta name="VSS Info"   content="$$Header: $" />

<link rel="stylesheet" type="text/css" href="aspx4devs.css" />

</head>

<body>

<h2>Data Bound Radio Button List Demo</h2>
<hr />

<form runat="server">

Select a wrapping option for your gift:
    <asp:RadioButtonList id=rbListDB
        OnSelectedIndexChanged="rbListDB_Changed"
        AutoPostBack="true" 
        runat="server"/>
         
    <p>
    <asp:Label id="msgDisplay" runat="server"/>
    </p>

</form>

</body>

</html>
