<%@ Page Language="VB" Debug="true" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>

<html>
<head>
<title>SqlCommandUpdate.aspx</title>
<script language="VB" runat="server">
Sub CreateSP(cnxOpen)
  Dim strSQL As String = _
   "CREATE PROCEDURE procReceiveStock " & _
   "  @productid INTEGER, @units INTEGER AS " & _
   "  IF (SELECT UnitsOnOrder FROM Products " & _
   "      WHERE ProductId = @ProductId)>= @units " & _
   "    BEGIN " & _
   "    UPDATE Products SET UnitsOnOrder = UnitsOnOrder - @units, " & _
   "    UnitsInStock = UnitsInStock + @units " & _
   "    WHERE ProductId = @productid " & _
   "    RETURN 0 " & _
   "    END " & _
   "  ELSE " & _
   "    RETURN 1 "

  ' Execute SqlCommand query to create stored proc
  Try
    Dim cmdCreateSP As SqlCommand  = New SqlCommand(strSQL, cnxOpen)
    cmdCreateSP.ExecuteNonQuery()
  Catch
    ' Ignore error that will occur if stored procedure
    ' is already defined.
  End Try
End Sub

Sub UpdateStock(Src as Object, E as CommandEventArgs)
  Dim strCnx As String = "server=localhost;uid=sa;pwd=;database=northwind;"
  Dim cnx As SqlConnection
  Dim prm As SqlParameter
  Dim cmd As SqlCommand
  Dim intReturn as Integer

  ' Create connection to SQL Server Northwind database
  cnx = New SqlConnection(strCnx)
  ' Open the connection
  cnx.Open()

  ' Create stored procedure
  Call CreateSP(cnx)

  ' Create & execute SqlCommand query to update records
  cmd  = New SqlCommand("procReceiveStock", cnx)
  cmd.CommandType = CommandType.StoredProcedure

  ' Create parameters
  prm = New SQLParameter("RETURN_VALUE", SqlDbType.Int)
  prm.Direction = ParameterDirection.ReturnValue
  cmd.Parameters.Add(prm)

  prm = New SQLParameter("@productid", SqlDbType.Int)
  prm.Direction = ParameterDirection.Input
  prm.Value = txtProductId.Text
  cmd.Parameters.Add(prm)

  prm = New SQLParameter("@units", SqlDbType.Int)
  prm.Direction = ParameterDirection.Input
  prm.Value = txtUnitsIn.Text
  cmd.Parameters.Add(prm)

  cmd.ExecuteNonQuery()

  intReturn = cmd.Parameters("RETURN_VALUE").Value
  If intReturn = 0 Then
     lblMsg.Text = "Record updated!"
  Else
     lblMsg.Text = "Record not updated." & _
      "<br />Either there is no product with this Id or there " & _
      " is there are not that many units on order for this product."
  End If

  cnx.Close()
End Sub
</script>
</head>
<body>
<form runat="server">
  <p>
  <asp:Label id="lblHeader" runat="server" 
      Text="<h2>SqlCommandSP Example</h2>" />
  </p>
  <table>
    <tr>
    <td>Product Id:</td>
    <td><asp:Textbox id="txtProductId" runat="server" /></td>
    </tr>
    <tr>
    <td>Units of Stock Received:</td>
    <td><asp:Textbox id="txtUnitsIn" runat="server" /></td>
    </tr>
    <tr>
    <td><asp:Button id="cmdCreate" runat="server"
      Text="Update Stock " OnCommand="UpdateStock" /></td>
    </tr>
  </table>
  <p>
  <asp:Label id="lblMsg" runat="server" 
      Style="Color:red;" />
  </p>
</form>
</body>
</html>