<%@ Page Language="VB" Debug="true" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.XML" %>

<html>
<head>
<title>DataSetFromXml1.aspx</title>
<script language="VB" runat="server">
Sub Page_Load(Src As Object, E As EventArgs) 
  ' Don't need to rebind for postbacks
  If Not Page.IsPostBack Then
     Call BindDataSet()
  End If
End Sub

Sub BindDataSet()
  ' Create the DataSet and bind to it
  dgrPeople.DataSource = FabricateDataSet()
  dgrPeople.DataBind()
End Sub

Function FabricateDataSet() As DataView
  ' Create new empty DataSet
  Dim dsFab As DataSet = New DataSet
  dsFab.DataSetName = "PeopleSet"

  Call GrabXML(dsFab, Server.MapPath("morepeople.xml"))

  Return dsFab.Tables("People").DefaultView
End Function

Sub GrabXML(ByRef ds As DataSet, strFile As String)
  ' Create a FileStream object for input
  Dim fs As New System.IO.FileStream _
   (strFile, System.IO.FileMode.Open)
  ' Create an XmlTextReader to read the file
  Dim xtr As New System.Xml.XmlTextReader(fs)
  ' Read the XML document and schema into the DataSet
  ds.ReadXml(xtr, XmlReadMode.ReadSchema)
  ' Close the XmlTextReader
  xtr.Close()
End Sub
</script>
</head>
<body>
<form runat="server">
  <asp:Label id="lblOut" runat="server"
   Text="<h2>Creating a DataSet From XML</h2>" />

  <asp:DataGrid id="dgrPeople" runat="server"
    BorderColor="black"
    BorderWidth="1"
    GridLines="Both"
    CellPadding="3"
    CellSpacing="0"
    Font-Name="Verdana"
    Font-Size="8pt"
    HeaderStyle-BackColor="#99ccff"
    AlternatingItemStyle-BackColor="lightgray" />
</form>
</body>
</html>


