<%@ Page Language="VB" Debug="true" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>

<html>
<head>
<title>DataViews.aspx</title>
<script language="VB" runat="server">
Sub Page_Load(Src As Object, E As EventArgs) 
  If Not Page.IsPostBack Then
    Dim strCnx As String = "server=localhost;uid=sa;pwd=;database=northwind;"
    Dim strSQLCust As String = _
     "SELECT CustomerId, CompanyName, Country FROM Customers ORDER BY CompanyName"
    Dim strSQLCountry As String = _
     "SELECT DISTINCT Country FROM Customers ORDER BY Country"
    Dim cnx As SqlConnection = New SqlConnection(strCnx)
    Dim sdaCust As SqlDataAdapter  = New SqlDataAdapter(strSQLCust, cnx)
    Dim sdaCountry As SqlDataAdapter  = New SqlDataAdapter(strSQLCountry, cnx)
    Dim dsNWind As DataSet = New DataSet
    Dim dvCountryCust As DataView
	
    ' Fill Customers DataTable
    sdaCust.Fill(dsNWind, "Customers")
    ' Fill Countries DataTable
    sdaCountry.Fill(dsNWind, "Countries")
    
    ' Bind Countries DataTable to drpCountry DropDownList control
    drpCountry.DataSource = dsNWind.Tables("Countries")
    drpCountry.DataTextField = "Country"
    drpCountry.DataValueField= "Country"
    drpCountry.DataBind()

    ' Initially disable drpCountryCust control
    drpCountryCust.Enabled = False

    ' Save dsNWind to data cache
    Cache("dsNWind") = dsNWind
  End If
End Sub

Sub FilterCountry(Src as Object, E as EventArgs)
  Dim dsNWind As DataSet
  Dim dvCountryCust As DataView

  ' Retrieve dsNWind from data cache
  dsNWind = Cache("dsNWind")

  ' Create new DataView using selection from drpCountry control
  dvCountryCust = New DataView(dsNWind.Tables("Customers"))
  dvCountryCust.RowFilter = "Country = '" & drpCountry.SelectedItem.Value & "'"
  dvCountryCust.Sort = "CompanyName"
  
  ' Enable drpCountryCust control and bind the DataView to it
  drpCountryCust.Enabled = True
  drpCountryCust.DataSource = dvCountryCust
  drpCountryCust.DataTextField = "CompanyName"
  drpCountryCust.DataValueField = "CustomerId"
  drpCountryCust.DataBind()
End Sub

Sub DisplayCountryCustomers(Src as Object, E as EventArgs)
  lblCountryCustPick.Text = "You have selected Customer " & _
   drpCountryCust.SelectedItem.Value & "."
End Sub
</script>
</head>
<body>
<form runat="server">
  <asp:Label id="lblTitle" runat="server"
   Text="<h2>Northwind Cascading DropDowns Example</h2>" />
  <p>Country: <asp:DropDownList id="drpCountry"
                 runat="server" AutoPostBack=true 
                 OnSelectedIndexChanged="FilterCountry" /></p>
  <p>Customers filtered by country: <asp:DropDownList id="drpCountryCust"
                 runat="server" AutoPostBack=true 
                 OnSelectedIndexChanged="DisplayCountryCustomers" /></p>
  <asp:Label id="lblCountryCustPick" runat="server"  
   style="Color:red"/></p>
</form>
</body>
</html>


